-- Set table.
script.on_init(function()
	if not global.my_entities then global.my_entities = {} end
end)
-- Register transport-belt and inserter.
local function on_built_entity(event)
	if event.created_entity.type == "transport-belt" or event.created_entity.type == "inserter" then
		table.insert(global.my_entities, event.created_entity)
	end
end
script.on_event(defines.events.on_built_entity,			on_built_entity)
script.on_event(defines.events.on_robot_built_entity,	on_built_entity)
-- Enable cheat mode.
script.on_event(defines.events.on_player_created, function(event)
	game.players[event.player_index].cheat_mode = true
end)


local function print_to_all_players(message)
	for _, player in pairs(game.players) do
		player.print(message)
	end
end

local function is_entity_disabled(entity)
   local control = entity.get_control_behavior()
   -- Does it have control behaviour? (Not connected = no control?)
   if control and control.valid then
      -- New API from Factorio 0.13.16
      if control.disabled == nil then
         print_to_all_players("Is control disabled? nil")
      else
         if control.disabled then
            print_to_all_players("Is control disabled? true")
            return false
         else
            print_to_all_players("Is control disabled? false")
            return true
         end
      end
   end
   
   -- No control? Because not connected to network?
   return true
end

script.on_event(defines.events.on_tick, function()
	for index, entity in ipairs(global.my_entities) do
		if entity.valid then
			is_entity_disabled(entity)
		else
			table.remove(global.my_entities, index)
		end
	end
end)